//GenererChiffres_dec_501f.js
// 20.01.2019 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / hsa@ringier.ch
//DESCRIPTION:Une colonne de chiffres avec dcimales

// activer l'affichage des dialogues ///////////////////////////////////////////////
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester si un document est ouvert ////////////////////////////////////////////////
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}
else {
	curDoc = app.documents[0];
}

// initialiser la liste des blocs de texte
var txtFrameArr = [];

// mmoriser et tester la slection
var nTxtFrames = 0;
curSel = app.selection;

if (curSel.length > 0) {
	for (var s=0; s<curSel.length; s++) {
		var curType = curSel[s].constructor.name;
		if (curType == "TextFrame") {
			txtFrameArr.push(curSel[s]);
		}
		else if (curType == "Group") {
			var allItems = curSel[s].allPageItems;
			for (var n=0; n<allItems.length; n++) {
				var curType = allItems[n].constructor.name;
				if (curType == "TextFrame") {
					txtFrameArr.push(allItems[n]);
				}
			}
		}
		else {
			if (curSel[0].hasOwnProperty("baseline")) {
				txtFrameArr.push(curSel[0].parentTextFrames[0]);
			}
		}
	}
	nTxtFrames = txtFrameArr.length;
	if (nTxtFrames == 0) {
		alert ("La slection ne contient pas de bloc texte.", "Stop");
		exit();
	}
}
else {
	alert ("Slectionner un bloc texte vide.", "Stop");
	exit();
}

// vrifier le rsultat ////////////////////////////////////////////////////////////
if (nTxtFrames > 1) { // plusieurs blocs texte sont slectionns
	alert ("Ne slectionner qu'un seul bloc texte.", "Attention");
	exit();
}
else if (nTxtFrames == 1) { // un seul bloc texte est slectionn
	var curFrame = txtFrameArr[0];
	var curCont  = curFrame.parentStory.contents;
	if (curCont.length == 0) { // le bloc texte est vide (= okay)
		// appeler la fonction qui lit les prfrences enregistres
		var defStr = getPrefs();
		// le fichier existe: extraire les valeurs
		if (defStr != "") {
			repDef = defStr.split("\n");
			stVal = repDef[0]*1;
			ndVal = repDef[1]*1;
			dgDec = repDef[2];
			rb01 = rb02 = 0;
			if (dgDec == "0") {
				rb01 = 1;
			}
			else if (dgDec == "1") {
				rb02 = 1;
			}
			spDec = repDef[3];
			rb03 = rb04 = rb05 = 0;
			if (spDec == "0") {
				rb03 = 1;
			}
			else if (spDec == "1") {
				rb04 = 1;
			}
			else if (spDec == "2") {
				rb05 = 1;
			}
			t100 = repDef[4]*1;
			t010 = repDef[5]*1;
			t001 = repDef[6]*1;
			dpDec = repDef[7];
			rb06 = rb07 = 0;
			if (dpDec == "0") {
				rb06 = 1;
			}
			else if (dpDec == "1") {
				rb07 = 1;
			}
			zeDec = repDef[8];
			rb08 = rb09 = 0;
			if (zeDec == "0") {
				rb08 = 1;
			}
			else if (zeDec == "1") {
				rb09 = 1;
			}
			adDec = repDef[9];
			rb10 = rb11 = rb12 = rb13 = 0;
			if (adDec == "0") {
				rb10 = 1;
			}
			else if (adDec == "1") {
				rb11 = 1;
			}
			else if (adDec == "2") {
				rb12 = 1;
			}
			else if (adDec == "3") {
				rb13 = 1;
			}
		}
		else { // sinon, utiliser ces valeurs de base
			stVal =  1;
			ndVal = 10;
			rb01  =  1;
			rb02  =  0;
			rb03  =  1;
			rb04  =  0;
			t100  =  0;
			t010  =  0;
			t001  =  0;
			rb05  =  0;
			rb06  =  1;
			rb07  =  0;
			rb08  =  1;
			rb09  =  0;
			rb10  =  1;
			rb11  =  0;
			rb12  =  0;
			rb13  =  0;
		}
		
		// appeler la fonction pour demander les valeurs (premire et dernire, etc.)
		var defNumbers = getNumbers();
		var startVal   = defNumbers[0];
		var stopVal    = defNumbers[1];
		var sepaDec    = defNumbers[2];
		var digiDec    = defNumbers[3]+1;
		var tun1Dec    = defNumbers[4];
		var tun2Dec    = defNumbers[5];
		var tun3Dec    = defNumbers[6];
		var direDec    = defNumbers[7];
		var zeroDec    = defNumbers[8];
		var addiDec    = defNumbers[9];
		
		// vider les prfrences rechercher/remplacer //////////////////////////////////////
		app.findTextPreferences = app.changeTextPreferences = null;
		app.findGrepPreferences = app.changeGrepPreferences = null;
		
		// mmoriser le sparateur dcimal slectionn
		var sepArr  = [".", ","];
		var sepChar = sepArr[sepaDec];
		
		// prparer la liste des dcimales
		var decArr = [];
		if (digiDec == 1) {
			if (tun1Dec == 0) { // = .0
				var decArr = [sepChar+0];
			}
			else if (tun1Dec == 1) {  // = .1
				var decArr = [];
				for (var n=0; n<10; n++) {
					decArr[n] = sepChar+n;
				}
			}
			else if (tun1Dec == 2) { // = .2
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<10; n=n+2) {
					decArr[ctr] = sepChar+n;
					ctr++;
				}
			}
			else if (tun1Dec == 3) { // = .5
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<10; n=n+5) {
					decArr[ctr] = sepChar+n;
					ctr++;
				}
			}
		}
		else if (digiDec == 2) {
			if (tun2Dec == 0) { // = .00
				var decArr = [sepChar+"00"];
			}
			else if (tun2Dec == 1) { // = .01
				var decArr = [];
				for (var n=0; n<100; n++) {
					decArr[n] = sepChar+("0"+n).slice(-2);
				}
			}
			else if (tun2Dec == 2) { // = .02
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<100; n=n+2) {
					decArr[ctr] = sepChar+("0"+n).slice(-2);
					ctr++;
				}
			}
			else if (tun2Dec == 3) { // = .05
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<100; n=n+5) {
					decArr[ctr] = sepChar+("0"+n).slice(-2);
					ctr++;
				}
			}
			else if (tun2Dec == 4) { // = .10
				var decArr = [];
				for (var n=0; n<10; n++) {
					decArr[n] = sepChar+n+"0";
				}
			}
			else if (tun2Dec == 5) { // = .20
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<10; n=n+2) {
					decArr[ctr] = sepChar+n+"0";
					ctr++;
				}
			}
			else if (tun2Dec == 6) { // = .25
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<100; n=n+25) {
					decArr[ctr] = sepChar+(n+"0").slice(0,2);
					ctr++;
				}
			}
			else if (tun2Dec == 7) { // = .50
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<10; n=n+5) {
					decArr[ctr] = sepChar+(n+"0").slice(0,2);
					ctr++;
				}
			}
		}
		else if (digiDec == 3) {
			if (tun3Dec == 0) { // = .000
				var decArr = [sepChar+"000"];
			}
			else if (tun3Dec == 1) { // = .001
				var decArr = [];
				for (var n=0; n<1000; n++) {
					decArr[n] = sepChar+("00"+n).slice(-3);
				}
			}
			else if (tun3Dec == 2) { // = .002
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<1000; n=n+2) {
					decArr[ctr] = sepChar+("00"+n).slice(-3);
					ctr++;
				}
			}
			else if (tun3Dec == 3) { // = .005
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<1000; n=n+5) {
					decArr[ctr] = sepChar+("00"+n).slice(-3);
					ctr++;
				}
			}
			else if (tun3Dec == 4) { // = .010
				var decArr = [];
				for (var n=0; n<100; n++) {
					decArr[n] = sepChar+("0"+n+"0").slice(-3);
				}
			}
			else if (tun3Dec == 5) { // = .020
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<100; n=n+2) {
					decArr[ctr] = sepChar+("0"+n+"0").slice(-3);
					ctr++;
				}
			}
			else if (tun3Dec == 6) { // = .025
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<1000; n=n+25) {
					decArr[ctr] = sepChar+("00"+n).slice(-3);
					ctr++;
				}
			}
			else if (tun3Dec == 7) {  // = .050
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<1000; n=n+50) {
					decArr[ctr] = sepChar+("00"+n).slice(-3);
					ctr++;
				}
			}
			
			
			else if (tun3Dec == 8) { // = .100
				var decArr = [];
				for (var n=0; n<10; n++) {
					decArr[n] = sepChar+n+"00";
				}
			}
			else if (tun3Dec == 9) { // = .200
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<10; n=n+2) {
					decArr[ctr] = sepChar+n+"00";
					ctr++;
				}
			}
			else if (tun3Dec == 10) { // = .250
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<1000; n=n+250) {
					decArr[ctr] = sepChar+(n+"00").slice(0,3);
					ctr++;
				}
			}
			else if (tun3Dec == 11) {  // = .500
				var decArr = [];
				var ctr = 0;
				for (var n=0; n<10; n=n+5) {
					decArr[ctr] = sepChar+(n+"00").slice(0,3);
					ctr++;
				}
			}
		}
		
		var nDec = decArr.length;
		
		if (zeroDec == 1) {
			if (startVal > -1 && stopVal > -1) {
				var nStart = (""+startVal).length;
				var nStop  = (""+stopVal).length; 
				if (nStart != nStop) {
					if (nStop > nStart) {
						nDiff = nStop-nStart;
					}
					else {
						nDiff = nStart-nStop;
					}
				}
				else {
					zeroDec = 0;
				}
			}
			else {
				var startTmp = startVal;
				if (startVal < 0) {
					startTmp = startVal-(startVal*2);
				}
				var stopTmp  = stopVal;
				if (stopVal < 0) {
					stopTmp = stopVal-(stopVal*2);
				}
				if (startTmp<stopTmp) {
					startTmp = stopTmp;
				}
				var nStart = (""+startTmp).length;
				var nStop  = 1;
				nDiff = nStart-nStop;
			}
		}
		if (addiDec == 2 || addiDec == 3) {
			var minusChar = "";
		}
		if (startVal < 0 || stopVal < 0) {
			var minusChar = "";
		}
		if (minusChar == "") {
			if (direDec == 0) {
				direDec = 1;
			}
			else if (direDec == 1) {
				direDec = 0;
			}
		}
		
		// annuler la slection
		app.selection = null;
		
		// modifierle sparateur temporairement
		if (zeroDec == 1) {
			if (sepChar == "."){
				sepChar = "";
				// prparer les prfrences rechercher/remplacer
				app.findTextPreferences.findWhat = ".";
				app.changeTextPreferences.changeTo = "";
			}
		}
		
		// une boucle  travers les valeurs
		if (direDec == 0) { // quand ascendant
			if (addiDec == 0) { // sans adjonction
				for (var n=startVal; n<stopVal; n++) {
					for (var d=0; d<nDec; d++) {
						curFrame.parentStory.insertionPoints.item(-1).contents = (n+decArr[d]+"\r");
					}
				}
				curFrame.parentStory.insertionPoints.item(-1).contents = ""+stopVal+decArr[0];
				if (zeroDec == 1) {
					if (sepChar == "") {
						// modifierle sparateur temporairement
						curFrame.parentStory.changeText();
					}
					// initialisiser la variable pour le(s) zro(s) de dbut
					var zeroPad = "";
					for (var e=nDiff; e>0; e--) {
						zeroPad += "0";
						app.findGrepPreferences.findWhat   = "^(-)?([0-9]{"+e+"})("+sepChar+")";
						app.changeGrepPreferences.changeTo = "$1"+zeroPad+"$2$3";
						curFrame.parentStory.changeGrep();
					}
				}
			}
			else if (addiDec == 1) { // insrer un tabulateur
				for (var n=startVal; n<stopVal; n++) {
					for (var d=0; d<nDec; d++) {
						curFrame.parentStory.insertionPoints.item(-1).contents = ("\t"+n+decArr[d]+"\r");
					}
				}
				curFrame.parentStory.insertionPoints.item(-1).contents = ("\t"+stopVal+decArr[0]+"\r");
				if (zeroDec == 1) {
					if (sepChar == "") {
						curFrame.parentStory.changeText();
					}
					var zeroPad = "";
					for (var e=nDiff; e>0; e--) {
						zeroPad += "0";
						app.findGrepPreferences.findWhat   = "(\t)(-)?([0-9]{"+e+"})("+sepChar+")";
						app.changeGrepPreferences.changeTo = "$1$2"+zeroPad+"$3$4";
						curFrame.parentStory.changeGrep();
					}
				}
			}
			else if (addiDec == 2) { // insrer un signe "moins"
				for (var n=startVal; n<stopVal; n++) {
					for (var d=0; d<nDec; d++) {
						curFrame.parentStory.insertionPoints.item(-1).contents = (minusChar+n+decArr[d]+"\r");
					}
				}
				curFrame.parentStory.insertionPoints.item(-1).contents = (minusChar+stopVal+decArr[0]+"\r");
				if (zeroDec == 1) {
					if (sepChar == "") {
						curFrame.parentStory.changeText();
					}
					var zeroPad = "";
					for (var e=nDiff; e>0; e--) {
						zeroPad += "0";
						app.findGrepPreferences.findWhat   = "^("+minusChar+")?(-)?([0-9]{"+e+"})("+sepChar+")";
						app.changeGrepPreferences.changeTo = "$1$2"+zeroPad+"$3$4";
						curFrame.parentStory.changeGrep();
					}
				}
			}
			else if (addiDec == 3) { // insrer un tabulateur et un signe "moins"
				for (var n=startVal; n<stopVal; n++) {
					for (var d=0; d<nDec; d++) {
						curFrame.parentStory.insertionPoints.item(-1).contents = ("\t"+minusChar+n+decArr[d]+"\r");
					}
				}
				curFrame.parentStory.insertionPoints.item(-1).contents = ("\t"+minusChar+stopVal+decArr[0]+"\r");
				if (zeroDec == 1) {
					if (sepChar == "") {
						curFrame.parentStory.changeText();
					}
					var zeroPad = "";
					for (var e=nDiff; e>0; e--) {
						zeroPad += "0";
						app.findGrepPreferences.findWhat   = "(\t)("+minusChar+")?(-)?([0-9]{"+e+"})("+sepChar+")";
						app.changeGrepPreferences.changeTo = "$1$2$3"+zeroPad+"$4$5";
						curFrame.parentStory.changeGrep();
					}
				}
			}
		}
		else if (direDec == 1) { // quand dscendant
			if (addiDec == 0) { // sans adjonction
				curFrame.parentStory.insertionPoints.item(-1).contents = (stopVal+decArr[0]+"\r");
				for (var n=stopVal-1; n>=startVal; n--) {
					for (var d=nDec-1; d>-1; d--) {
						curFrame.parentStory.insertionPoints.item(-1).contents = (n+decArr[d]+"\r");
					}
				}
				if (zeroDec == 1) {
					if (sepChar == "") {
						curFrame.parentStory.changeText();
					}
					var zeroPad = "";
					for (var e=nDiff; e>0; e--) {
						zeroPad += "0";
						app.findGrepPreferences.findWhat   = "^(-)?([0-9]{"+e+"})("+sepChar+")";
						app.changeGrepPreferences.changeTo = "$1"+zeroPad+"$2$3";
						curFrame.parentStory.changeGrep();
					}
				}
			}
			else if (addiDec == 1) { // insrer un tabulateur
				curFrame.parentStory.insertionPoints.item(-1).contents = ("\t"+stopVal+decArr[0]+"\r");
				for (var n=stopVal-1; n>=startVal; n--) {
					for (var d=nDec-1; d>-1; d--) {
						curFrame.parentStory.insertionPoints.item(-1).contents = ("\t"+n+decArr[d]+"\r");
					}
				}
				if (zeroDec == 1) {
					if (sepChar == "") {
						curFrame.parentStory.changeText();
					}
					var zeroPad = "";
					for (var e=nDiff; e>0; e--) {
						zeroPad += "0";
						app.findGrepPreferences.findWhat   = "(\t)(-)?([0-9]{"+e+"})("+sepChar+")";
						app.changeGrepPreferences.changeTo = "$1$2"+zeroPad+"$3$4";
						curFrame.parentStory.changeGrep();
					}
				}
			}
			else if (addiDec == 2) { // insrer un signe "moins"
				curFrame.parentStory.insertionPoints.item(-1).contents = (minusChar+stopVal+decArr[0]+"\r");
				for (var n=stopVal-1; n>startVal-1; n--) {
					for (var d=nDec-1; d>-1; d--) {
						curFrame.parentStory.insertionPoints.item(-1).contents = (minusChar+n+decArr[d]+"\r");
					}
				}
				if (zeroDec == 1) {
					if (sepChar == "") {
						curFrame.parentStory.changeText();
					}
					var zeroPad = "";
					for (var e=nDiff; e>0; e--) {
						zeroPad += "0";
						app.findGrepPreferences.findWhat   = "^("+minusChar+")?(-)?([0-9]{"+e+"})("+sepChar+")";
						app.changeGrepPreferences.changeTo = "$1$2"+zeroPad+"$3$4";
						curFrame.parentStory.changeGrep();
					}
				}
			}
			else if (addiDec == 3) { // insrer un tabulateur et un signe "moins"
				curFrame.parentStory.insertionPoints.item(-1).contents = ("\t"+minusChar+stopVal+decArr[0]+"\r");
				for (var n=stopVal-1; n>startVal-1; n--) {
					for (var d=nDec-1; d>-1; d--) {
						curFrame.parentStory.insertionPoints.item(-1).contents = ("\t"+minusChar+n+decArr[d]+"\r");
					}
				}
				if (zeroDec == 1) {
					if (sepChar == "") {
						curFrame.parentStory.changeText();
					}
					var zeroPad = "";
					for (var e=nDiff; e>0; e--) {
						zeroPad += "0";
						app.findGrepPreferences.findWhat   = "(\t)("+minusChar+")?(-)?([0-9]{"+e+"})("+sepChar+")";
						app.changeGrepPreferences.changeTo = "$1$2$3"+zeroPad+"$4$5";
						curFrame.parentStory.changeGrep();
					}
				}
			}
		}
		
		// remplacer le "" temporaire par un point
		if (zeroDec == 1) {
			if (sepChar == ""){
				app.findTextPreferences.findWhat = "";
				app.changeTextPreferences.changeTo = ".";
				curFrame.parentStory.changeText();
			}
		}
		
		if (minusChar == "") {
			app.findTextPreferences.findWhat   = "-";
			app.changeTextPreferences.changeTo = "";
			curFrame.parentStory.changeText();
		}
		if (zeroDec == 1) {
			curFrame.parentStory.recompose();
		}
	}
	else {
		alert ("Le bloc texte doit tre vide.", "Stop");
		exit();
	}
}

//rtablir les prfrences rechercher/remplacer ////////////////////////////////////
app.findTextPreferences = app.changeTextPreferences = null;
app.findGrepPreferences = app.changeGrepPreferences = null;

// annoncer la fin de l'action /////////////////////////////////////////////////////
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Termin.");
dlog.show();
// une petite pause
$.sleep(444);
// fermer le dialogue
dlog.close();


/////////////////////////////////////////////////////////////////////////////////////
// prparer les informations ///////////////////////////////////////////////////////
function getPrefs() {
	var defStr = "";
	// lire le fichier contenant les valeurs enregistres
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/Chiffres_dec_501.txt");
	}
	else {
		var f = new File("~/Library/Preferences/Chiffres_dec_501.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			defStr = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return defStr;
}

// afficher un dialogue (premire valeur, dernire valeur, etc.) ///////////////////
function getNumbers() {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth0 =  83;
	var labelWidth1 = 162;
	var labelWidth2 = 128;
	var fieldWidth1 =  64;
	var bttnsWidth1 = 124;
	var tuneUnits01 = [".0", ".1", ".2", ".5"];
	var tuneUnits02 = [".00", ".01", ".02", ".05", ".10", ".20", ".25", ".50"];
	var tuneUnits03 = [".000", ".001", ".002", ".005", ".010", ".020", ".025", ".050", ".100", ".200", ".250", ".500"];
	var aDialog = app.dialogs.add({name:"Une colonne de valeurs (que des chiffres)"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Premire valeur ", minWidth:labelWidth1});
				var startField = integerEditboxes.add({editValue:stVal, minWidth:fieldWidth1});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Dernire valeur ", minWidth:labelWidth1});
				var stopField = integerEditboxes.add({editValue:ndVal, minWidth:fieldWidth1});
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Sparateur dcimal ", minWidth:labelWidth2});
						with (sepButtns = radiobuttonGroups.add()) {
							radiobuttonControls.add({staticLabel:" point", checkedState:rb01, minWidth:bttnsWidth1});
							radiobuttonControls.add({staticLabel:" virgule", checkedState:rb02});
						}
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Les dcimales ", minWidth:labelWidth2});
						with (digButtns = radiobuttonGroups.add()) {
							radiobuttonControls.add({staticLabel:" 1", checkedState:rb03, minWidth:bttnsWidth1});
							radiobuttonControls.add({staticLabel:" 2", checkedState:rb04});
							radiobuttonControls.add({staticLabel:" 3", checkedState:rb05});
						}
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"La finesse ", minWidth:labelWidth0});
						var tuneDropdown100 = dropdowns.add({stringList:tuneUnits01, selectedIndex:t100, minWidth:39});
						staticTexts.add({staticLabel:" (diximes)"});
						staticTexts.add({staticLabel:" ", minWidth:34});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:" ", minWidth:labelWidth0});
						var tuneDropdown010 = dropdowns.add({stringList:tuneUnits02, selectedIndex:t010, minWidth:39});
						staticTexts.add({staticLabel:" (centimes)"});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:" ", minWidth:labelWidth0});
						var tuneDropdown001 = dropdowns.add({stringList:tuneUnits03, selectedIndex:t001, minWidth:39});
						staticTexts.add({staticLabel:" (millimes)"});
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"La direction ", minWidth:labelWidth2});
						with (dirButtns = radiobuttonGroups.add()) {
							radiobuttonControls.add({staticLabel:" ascendant", checkedState:rb06, minWidth:bttnsWidth1});
							radiobuttonControls.add({staticLabel:" descendant",  checkedState:rb07});
						}
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Zros de dbut ", minWidth:labelWidth2});
						with (zerButtns = radiobuttonGroups.add()) {
							radiobuttonControls.add({staticLabel:" non", checkedState:rb08, minWidth:bttnsWidth1});
							radiobuttonControls.add({staticLabel:" oui",   checkedState:rb09});
						}
					}
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Insrer devant ", minWidth:labelWidth2});
						with (addButtns = radiobuttonGroups.add()) {
							radiobuttonControls.add({staticLabel:" rien",        checkedState:rb10, minWidth:bttnsWidth1});
							radiobuttonControls.add({staticLabel:" tabulateur",     checkedState:rb11});
							radiobuttonControls.add({staticLabel:" signe moins",  checkedState:rb12});
							radiobuttonControls.add({staticLabel:" tab et moins", checkedState:rb13});
						}
					}
				}
			}
		}
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"", minWidth:0});
			}
		}

	}
	// afficher le dialogue
	if(aDialog.show() == true) {
		var startVal = startField.editValue;
		var stopVal  = stopField.editValue;
		var sepDec   = sepButtns.selectedButton;
		var digDec   = digButtns.selectedButton;
		var tun100   = tuneDropdown100.selectedIndex;
		var tun010   = tuneDropdown010.selectedIndex;
		var tun001   = tuneDropdown001.selectedIndex;
		var dirDec   = dirButtns.selectedButton;
		var zerDec   = zerButtns.selectedButton;
		var addDec   = addButtns.selectedButton;
		// supprimer le dialogue
		aDialog.destroy();
		// la liste des rglages...
		var prefsArr = [startVal, stopVal, sepDec, digDec, tun100, tun010, tun001, dirDec, zerDec, addDec];
		// ... la convertir en chane de texte...
		var curDef = prefsArr.join("\n");
		// ... appeler la fonction qui crit la chane dans un fichier
		writeResult(curDef);
		// renvoyer le rsultat  l'appel
		if (startVal<stopVal) {
			return prefsArr;
		}
		else {
			return [stopVal, startVal, sepDec, digDec, tun100, tun010, tun001, dirDec, zerDec, addDec];
		}
	}
	else {
		aDialog.destroy();
		exit();
	}
}

////////////////////////////////////////////////////////////////////////////////////
// crire le rsultat dans un fichier //////////////////////////////////////////////
function writeResult(curDef) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/Chiffres_dec_501.txt");
	}
	else {
		var f = File("~/Library/Preferences/Chiffres_dec_501.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curDef);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}